package com.example.andersb.webservicejson;

import android.app.Activity;
import android.os.AsyncTask;
import android.os.Bundle;
import android.util.Log;
import android.widget.TextView;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.*;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLConnection;

public class WebServiceJsonActivity extends Activity {

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_web_service_json);
        final ReadJSONFeedTask task = new ReadJSONFeedTask();
        // task.execute("http://extjs.org.cn/extjs/examples/grid/survey.html");
        task.execute("http://date.jsontest.com");
        // task.execute("http://www.easj.dk/");
        // from http://www.jsontest.com/#date
    }

    private class ReadJSONFeedTask extends AsyncTask<String, Void, String> {

        @Override
        protected String doInBackground(String... urls) {
            try {
                return readJSonFeed(urls[0]);
            } catch (IOException ex) {
                Log.e("SHIT", ex.toString());
                return ex.toString();
            }
        }

        @Override
        protected void onPostExecute( String result) {
            final TextView textView = (TextView) findViewById(R.id.result);
            // textView.setText(result);
            try {
                if (result.charAt(0)!= '[') {
                    result = '['+ result + ']';
                }
                JSONArray jsonArray = new JSONArray(result);
                for (int i = 0; i < jsonArray.length(); i++) {
                    JSONObject jsonObject = jsonArray.getJSONObject(i);
                    final String appeId = jsonObject.getString("date");
                    final String inputTime = jsonObject.getString("time");
                    textView.append(appeId + ": " + inputTime + "\n");
                }
            } catch (JSONException ex) {
                textView.append(ex.toString());
            }
        }

    }

    private String readJSonFeed(String urlString) throws IOException {
        StringBuilder stringBuilder = new StringBuilder();
        // HttpClient client = new DefaultHttpClient();
        // HttpGet httpGet = new HttpGet(urlString);
        // HttpResponse response = client.execute(httpGet);
        // final StatusLine statusLine = response.getStatusLine();
        // final int statusCode = statusLine.getStatusCode();
        // if (statusCode == 200) {
        // final HttpEntity entity = response.getEntity();
        // final InputStream content = entity.getContent();
        final InputStream content = openHttpConnection(urlString);
        final BufferedReader reader = new BufferedReader(new InputStreamReader(
                content));
        while (true) {
            final String line = reader.readLine();
            if (line == null)
                break;
            stringBuilder.append(line);
        }
        // } else {
        // Log.e("SHIT", "HTTP status code: " + statusCode);
        // stringBuilder.append("Cannot download content. Status code: "
        // + statusCode);
        // }
        return stringBuilder.toString();
    }

    private InputStream openHttpConnection(final String urlString)
            throws IOException {
        final URL url = new URL(urlString);
        final URLConnection conn = url.openConnection();
        if (!(conn instanceof HttpURLConnection))
            throw new IOException("Not an HTTP connection");
        final HttpURLConnection httpConn = (HttpURLConnection) conn;
        httpConn.setAllowUserInteraction(false);
        // No user interaction like dialog boxes, etc.
        httpConn.setInstanceFollowRedirects(true);
        // follow redirects, response code 3xx
        httpConn.setRequestMethod("GET");
        httpConn.connect();
        final int response = httpConn.getResponseCode();
        if (response == HttpURLConnection.HTTP_OK) {
            return httpConn.getInputStream();
        } else {
            throw new IOException("HTTP response not OK");
        }
    }

}

